
//// 0 = GRANNY  ///   100 = PLASMA  ///   200 =  LG  ///  300 =  ROX  ///   400 =  RG  ///    500 =  BFG


// input: origin, team, clientnum, enemy, teammate, ineyes
weapon/grenade/flash {
	color	1 0.7 0
	size 300  
	light
}
 
 

weapon/grenade/projectile {
	// Render the grenade model
	model		"models/ammo/grenade1.md3"
        // wolfcam need to do model rotation yourself
        if velocity {
           rotate time * 1000 / 4
        }
	anglesModel
	
	
	 ////////////////////////// 
	shader flareshader
	 distance 1   //  t9   
	{
		wobble	dir velocity 0
		scale	velocity velocity 0
		size	3.5      //                   GL   TRAIL
		emitter 0.5 + rand *0.25 {   // .35
			colorFade 0 
			color .5 .25 0
			Sprite
		}
	}	
}

weapon/grenade/impact { 
   sound	sound/weapons/rocket/rocklx1a.wav
	// Will be the light colour
	color 1 1 0
	emitter 0.5 {
		Sprite	
		size 300  
		Light
	}
	

	color  1 .75 0          // PHAT PARTZ
	alpha	0 
	shader	flareShader
	repeat	2  {
		// random	velocity
		scale	velocity velocity 10 
		size	250
		emitter   0.75 {   
			moveBounce 0 0 
			colorFade 0 
			Sprite
		}
	}
	
  
	color  1 1 1         //  SMALL PARTZ
	alpha	0 
	shader	flareShader
	repeat	100 {
		  random	velocity
		scale	velocity velocity  400 + rand*150
		size	5 + rand *5
		emitter "0.25 + rand*0.15" {
			moveBounce 0 0 
			colorFade 0 
			Sprite
		}
	}  
	color  1 .25 0        // ON SPOT MARK PARTZ
	alpha	0 
	shader	flareShader
	repeat 150  {
		  random	velocity
		scale	velocity velocity 55 +rand*55
		size	3  + rand*2
		emitter 2 + rand*2 {
			 moveBounce 2 0.5
			moveGravity    150 1
			colorFade 0 
			Sprite
		}
	}  
}


weapon/grenade/trail {
	// The standard                 SMOKE PUFF  
	alpha	0.25
	shader	smokePuff
	angle	360 * rand
	// Emit a sprite every 50 milliseconds
	interval  0.025 {
		emitter 0.700 {
			alphaFade	0
			size		8 + lerp * 32
			sprite		cullNear
		}
	}
}

 
//// 0 = GRANNY  ///   100 = PLASMA  ///   200 =  LG  ///  300 =  ROX  ///   400 =  RG  ///    500 =  BFG


// input: origin, team, clientnum, enemy, teammate, ineyes
weapon/plasma/flash {
	color	0.6 0.6 1
	size 300 + rand*32
	light
}
 
 

weapon/plasma/projectile {
		color  0.2 0.4 0.6  //  .25 .75 1 
    size 300
    light
	rotate    rand*360
	size 15                        // THE SPRITE FOR THE PLASMA
	shader	     sprites/plasma1
  sprite
	// Plasma flying sound
	loopSound	"sound/weapons/plasma/lasfly.wav"

	color	 0 .05 .1  // 0 .05 .25                                    // TRAILCOLOR   gets bright because of low distance 
	alpha	0    //??       ///  ===          plasma TRAIL  
	shader	  raildisc  ///   flareshader  ///   
	
	distance 5 //0 + rand *10                                             
	{  
		normalize parentVelocity v0
		inverse v0
		wobble v0 velocity 5 ///  + rand*2   //STRAIGHTEN OUT TRAIL
  // scale	velocity velocity 50 + rand*50  // ??
		emitter 0.13    {
			size	17    
			colorFade 0
			moveGravity 0
			  Sprite
		}
	} 
} 




// input: origin, angles, velocity, dir (normalized), axis
//
// no client info
weapon/plasma/trail {

}

// input: origin, dir, surfacetype
//
// no client info
weapon/plasma/impact {
	vibrate 10
	sound	sound/weapons/plasma/plasmx1a.wav

	shader	plasmaExplosion
	model	models/weaphits/ring02.md3
	// Show the ring impact model on a random rotation around it's direction
	rotate    rand*360
	emitter 0.6 {
		dirModel
	}
	size	24
	shader	gfx/damage/plasma_mrk
	Decal energy
}





 
 
 
//// 0 = GRANNY  ///   100 = PLASMA  ///   200 =  LG  ///  300 =  ROX  ///   400 =  RG  ///    500 =  BFG



// input: origin, team, clientnum, enemy, teammate, ineyes
weapon/lightning/flash {
	color	  0.6 0.5  0.7   //.1 .5 .7  //  .3 .7 .1   //                             //   LG  Light
	size 300 + rand*32
	light
}


// input: origin, dir, end (wolfcam), team, clientnum, enemy, teammate, ineyes
weapon/lightning/trail {
	//shader "lightningBoltNew"
        // wolfcam ql uses lightningBolt[1 - 7]
        shader flareshader  //  "lightningBolt2"
	// Standard q3 beam size
	
	size   7.5
	color   .7 .5 .8 ///  0.6 0.4 .7                                //  LG BEAM
	//width 20
	// The beam is repeated every 45 degrees
	angle    45 
	 //  higher = thinner
	// Draw the beam between origin in direction of
        if ineyes {
        	beam depthhack
        } else {
                beam
        } 
		// repeat 2
	// Length of beam in t0
	t0 dir
	// Check if we need to render the impact flash effect thing
	// That means we end before the maximum lightning range
	if ( t0 < 768 ) {
		// Clear the previous shader so it uses the one in the model
		shaderClear
		model "models/weaphits/crackle.md3"
		size 0.5
		// Slightly before the endpoint
		addScale origin dir origin ( (t0 - 5 ) / t0 )
		// Just a random model in it's angles
		angles0 rand * 360
		angles1 rand * 360
		angles2 rand * 360
		anglesModel
	}
}

// input: origin, dir, team, clientnum, enemy, teammate, ineyes, surfacetype
weapon/lightning/impact {
	// random impact sound
	soundList {
		sound/weapons/lightning/lg_hit.wav
		sound/weapons/lightning/lg_hit2.wav
		sound/weapons/lightning/lg_hit3.wav
	}
	// Hole mark shader decal
	shader	gfx/damage/hole_lg_mrk
	size	5  //  12                                                         ///  LG  BLACK IMPCT
	decal

	
	
	//  from impact surface
	shader	flareshader  //  smokepuff
	alpha	0 
	color	    .15   .13   .18       //  .1 .05 .15  ///                  ///  LG   IMPACT STUFF
	repeat  2 {     ///  higher kills FPS
		wobble	dir velocity 25 + rand*10
		scale	velocity velocity  55 + rand*10
		size	15 + rand *10
	// width 100 +rand*10   no width on flareshader?
		emitter  0.5 + rand*0.5  ///  0.5 + rand* .25  
		{
			moveGravity     300
			moveBounce  0.5 0.5
			colorfade 0  //   alphaFade 0
		    sprite  // spark
		}
	}
} 


 

//// 0 = GRANNY  ///   100 = PLASMA  ///   200 =  LG  ///  300 =  ROX  ///   400 =  RG  ///    500 =  BFG





// input: origin, team, clientnum, enemy, teammate, ineyes
weapon/rocket/flash {
	color	1 0.75 0
	size 300 + rand*32
	light
}

// input: velocity, dir (normalized), rotate, origin, angles, axis, size
//
// no client info rocket projectiles
weapon/rocket/projectile {
	// Render the rocket
	model		"models/ammo/rocket/rocket.md3"
        // wolfcam need to do model rotation yourself
        rotate time * 1000 / 4
	dirModel

	// Sound generated by the flying rocket
	loopSound	"sound/weapons/rocket/rockfly.wav"
	
	
////   ADD TRAIL
        color   1  .2  0.1    ///  === TRAIL  normal
        alpha   0   //??    
        shader  flareShader
         
        distance    10
            {  // 900ups * (1000.0 / 125.0)
                normalize parentVelocity v0
                inverse v0
                wobble v0 velocity 1   //  + rand*1   //STRAIGHTEN OUT TRAIL
                scale   velocity velocity 500     + rand*50  //SPEED OF TRAIL (REALISTIC for rox:1000)
                emitter 0.05  + rand*0.01  {
                        size    4      +rand* 8    * ( 2  - 2  * lerp * 2  )
                        colorFade 0.001
                        moveGravity 0
                        Sprite
                }
        } 

}



// input: origin, angles, velocity, dir (normalized), axis
//
// no client info for rocket trails
weapon/rocket/trail {
	// Set the base yellow color
	color	1 0.75 0

	size	200
	Light

	// The standard                SMOKE PUFF 
	color	1 1 1
	alpha	0.3
	shader	smokePuff
	rotate	360 * rand
	distance 25 + rand* 50 {
		emitter 1.24 {
			alphaFade	0 
			size		8 + lerp *50
			sprite		cullNear
		}
	}
}

// input: origin, dir
//
// no client info for rocket impact
weapon/rocket/impact {
	vibrate 70  
	sound	sound/weapons/rocket/rocklx1a.wav 
	// Mark on the wall, using direction from parent
	shader gfx/damage/burn_med_mrk
	size	64   //               DUST MRK
	Decal

	
	shader rocketExplosion
	size      66    //                ANIMATING SPRITE OF THE EXPLOSION
	// Will be the light colour
	color 1 .25 0
	emitter 1 {
		Sprite
		// size will goto zero after 0.5 of the time
		size 300
		Light
	} 
	
	
	color  1 .25 0        // ON SPOT MARK PARTZ
	alpha	0 
	shader	flareShader
	repeat  99  {
		  random	velocity
		scale	velocity velocity 50 +rand*55
		size	3  + rand*2
		emitter 1 + rand*0.5 {
			 moveBounce 0.7 0.7
			moveGravity    200
			colorFade 0 
			Sprite
		}
	}  
	
}





//// 0 = GRANNY  ///   100 = PLASMA  ///   200 =  LG  ///  300 =  ROX  ///   400 =  RG  ///    500 =  BFG



// input: origin, team, clientnum, enemy, teammate, ineyes
weapon/rail/flash {
	color	1 0.6 0
	size 300 + rand*32
	light
}

// input: origin, dir, team, clientnum, enemy, teammate, ineyes, surfacetype
weapon/rail/impact {
	vibrate 50
	sound	sound/weapons/plasma/plasmx1a.wav

	// The white expanding impact disc
	rotate    rand*360
	shader	railExplosion
	model	models/weaphits/ring02.md3
	emitter 0.6 {
		dirModel
	} 
	size	24
	shader	gfx/damage/plasma_mrk
	Decal energy
	
///    ADDD  EFFEKTX

         
        alpha   0
        color 1 .1 0 //     .75 .5 .25  //   1 .75 .5 // IMPCT SPOT
		shader    flareshader
        repeat 1  {
                wobble  dir velocity  0
                scale   velocity velocity 2
              size 20                                                                                                                          
                emitter 1  {
                        moveBounce 1 1                                           
                        colorFade 0 
                          sprite
                }
        }
	
	
	
}

weapon/rail/trail { 
	size  r_railCoreWidth*0.5
	shader railCore
	emitter cg_railTrailTime * 0.001 {
		colorFade 0
		Beam
	}
	shader railDisc
	 
	pushparent color2
	pop color
	if cg_oldrail {
		 
		size r_railWidth*0.5
		 
		width r_railSegmentLength
		emitter cg_railTrailTime * 0.001 {
			colorFade 0.1
			Rings
		}
	} else {                                          // stupid RAIL SPIRAL
		 
		t0 dir
		normalize dir
		 
		perpendicular dir v0
		 
		scale v0 v0  0 ///  5
		size 1.1
		 
		t1 rand*360
		 
		repeat ( t0 / 1 ) {
			rotatearound v0 dir v1 t1
			 
			t1 t1 + 0
			addScale v1 dir origin loop * t0
			add parentOrigin origin origin
			emitter 0.6 + loop * t1 * 0  {
		 
				colorFade 0 
				Sprite
			}
		}
	}
}




//// 0 = GRANNY  ///   100 = PLASMA  ///   200 =  LG  ///  300 =  ROX  ///   400 =  RG  ///    500 =  BFG





// input: origin, team, clientnum, enemy, teammate, ineyes
weapon/bfg/flash {
	color	1 0.7 1
	size 300 + rand*32
	light
}

// input: velocity, dir (normalized), rotate, origin, angles, axis, size
//
// no client info
weapon/bfg/projectile {
	// ze model
	model		models/weaphits/bfg.md3
	dirModel
	// ze flight sound
	loopSound	"sound/weapons/rocket/rockfly.wav"
}

// input: origin, angles, velocity, dir (normalized), axis
//
weapon/bfg/trail {
        // World Light
        color           .2 .9 .3  //// 0.2 0.2 1
 
        size    300
        Light
 
        color    .2 .9 .3  //// 0.2 0.2 1
        alpha   0.50
        shader  flareShader
        distance 15 {
                normalize parentVelocity v0
                inverse v0
                wobble v0 velocity 5 + rand*10
                scale   velocity velocity 75 + rand*52
                emitter 0.01 + rand*0.55 {
                        size    10 * ( 1 - 0.5 * lerp * 1.5 )  // dust
                        colorFade 0.001
                        moveGravity 10
                        Sprite
                }
        }
}

// input: origin, dir
//
// no client info
weapon/bfg/impact {
	vibrate 100
	sound	sound/weapons/rocket/rocklx1a.wav
	// Mark on the wall
	shader	gfx/damage/burn_med_mrk
	size	32
	decal

	// Animating sprite of the explosion
	shader bfgExplosion
	size 40
	emitter 0.6 {
		sprite
	}
}

 
 
 
 
 
 
 
 
 
  
















///   REST






// q3mme example scripts combined into one file with example changes to make
// it compatible with wolfcam

// wolfcam additional inputs to some scripts are:
//    team         0 free, 1 red, 2 blue, 3 spectator
//    clientnum
//    enemy        1 if enemy of whoever is being specced in demo
//    teammate
//    ineyes       1 if first person view is with this player
//    surfacetype  for impact scripts:  0 not specified, 1 metal, 2 wood,
//                   3 dust
//

/////////////////////////////////////////////////////


// Some general fx script you could use in the effects editor when really bored
mme/decal {
	Trace
	decalTemp
}

mme/quad {
	quad
}


mme/model {
	anglesModel
}

// Talk sprite
// input: origin, team, clientnum, enemy, teammate, ineyes
player/talk {
        if ineyes != 1 {
        	size		10
	        shader		sprites/balloon3
                Sprite
        }
}

// Impressive sprite
// input: origin, team, clientnum, enemy, teammate, ineyes
player/impressive {
        if ineyes != 1 {
        	size		10
	        shader		medal_impressive
                Sprite
        }
}

// Excellent sprite
// input: origin, team, clientnum, enemy, teammate, ineyes
player/excellent {
        if ineyes != 1 {
        	size		10
                shader		medal_excellent
                Sprite
        }
}

// Holy shit medal from ra3
// input: origin, team, clientnum, enemy, teammate, ineyes
player/holyshit {
        if ineyes != 1 {
        	size		10
                shader		medal_holyshit
                Sprite
        }
}

// Accuracy medal
// input: origin, team, clientnum, enemy, teammate, ineyes
player/accuracy {
        if ineyes != 1 {
        	size		10
                shader		medal_accuracy
                Sprite
        }
}

// Gauntlet sprite
// input: origin, team, clientnum, enemy, teammate, ineyes
player/gauntlet {
        if ineyes != 1 {
        	size		10
	        shader		medal_gauntlet
                Sprite
        }
}

// connection sprite
// input: origin, team, clientnum, enemy, teammate, ineyes
player/connection {
        if ineyes != 1 {
        	size		10
	        shader		disconnected
                Sprite
        }
}

// haste/speed trail
// input: origin, angles, velocity, dir (normalized), team, clientnum,
//        enemy, teammate, ineyes
player/haste {
	interval 0.1 {
		shader		hasteSmokePuff
		emitter 0.5 {
			size	6 + 10 * wave( 0.5  * lerp )
			alphaFade	0
			sprite	cullNear
		}
	}
}

// flight trail -- wolfcam addition, not in q3mme
// input: origin, angles, velocity, dir (normalized), team, clientnum,
//        enemy, teammate, ineyes
player/flight {
	interval 0.1 {
		shader		hasteSmokePuff
		emitter 0.5 {
			size	6 + 10 * wave( 0.5  * lerp )
			alphaFade	0
			sprite	cullNear
		}
	}
}

// wolfcam addition, not in q3mme:
//
// player/head/trail
// player/torso/trail
// player/legs/trail
//
// input: origin, angles, velocity, dir (normalized), team, clientnum,
//        enemy, teammate, ineyes

//player/legs/trail {
//	interval 0.1 {
//		shader		sprites/balloon3
//		emitter 0.5 {
//			size	6 + 10 * wave( 0.5  * lerp )
//			alphaFade	0
//			sprite	cullNear
//		}
//	}
//}


// teleport in effect and sound effect
// input: origin
player/teleportIn {
	sound	sound/world/telein.wav
        // Show the fading spawn tube for 0.5 seconds
	//model models/misc/telep.md3
        // wolfcam ql uses different model
        model models/powerups/pop.md3
	//shader teleportEffect  // wolfcam for ql don't add shader
	emitter 0.5 {
		colorFade 0
		anglesModel
	}
}

// teleport out effect and sound effect
// input: origin
player/teleportOut {
	sound	sound/world/teleout.wav
        //Show the fading spawn tube for 0.5 seconds
	//model	models/misc/telep.md3
        // wolfcam ql uses different model
        model models/powerups/pop.md3
	//shader	teleportEffect  // wolfcam for ql don't add shader
	emitter 0.5 {
		colorFade 0
		anglesModel
	}
}


// Freezetag thaw
// input: origin, velocity, team, clientnum, enemy, teammate, ineyes
//
// wolfcam: guessing that velocity corresponds to player
//
// player/thawed {}


// General weapon effects
// flash is a 0.25 second event after a weapon is fired
// fire is a single event when weapon is fired
// impact is for weapons impact on something or explode like grenades
// trail is a single event for weapons without projectiles or a
//      constant event when projectile is in motion projectile is for
//      rendering the specific projectile

// wolfcam: the other ql weapons also available as 'nailgun', 'prox',
//   and 'chaingun'
// wolfcam: weapons also have, in addition to /impact scripts, /impactflesh
//   scripts.  ex:  weapon/plasma/impactflesh
//   inputs for 'impactflesh' are: origin and dir
//
//   If a weapon doesn't have an impactflesh script 'weapon/common/impactFlesh'
//   will be checked.  'weapon/common/impactFlesh' would be a good place to
//   place custom hit sparks.


// input: origin, dir, team, clientnum, enemy, teammate, ineyes
//weapon/common/impactFlesh {
//	shader flareShader
//        size 5
//        color 1 0 1
//        emitter 4 {
//               //origin2 origin2 + lerp * 8
//               velocity2 200
//               moveGravity 0
//               Sprite
//        }
//}


// Bubbles in the water
// input: origin
weapon/common/bubbles {
        shader waterbubble
	distance 5+rand*10 {
		size 1 + rand * 2
		random	dir
		addScale origin dir origin 10 * rand
		emitter 1+rand*0.25 {
			alphaFade 0
			origin2 origin2 + lerp * 8
			Sprite
		}
	}
}


// input: origin, team, clientnum, enemy, teammate, ineyes
weapon/shotgun/flash {
	color	1 1 0
	size 300 + rand*32
	light
}

// input: origin, dir, team, clientnum, enemy, teammate, ineyes, surfacetype
weapon/shotgun/impact {
	vibrate 1
	// Bullet mark on the wall, shotgun ones are smaller
	shader		gfx/damage/bullet_mrk
	size		4
	Decal

	// explosion cone with animating shader
	size		1
	shader		bulletExplosion
	model		models/weaphits/bullet.md3
	rotate		rand*360
	emitter 0.6 {
		dirModel
	}

	// a single sprite shooting up from impact surface
	wobble	dir velocity 10 + rand*30
	scale	velocity velocity 200 + rand*50
	size	1 + rand*0.5
	shader	flareShader
	alpha	0.8
	color	1 0.6 0.3
	emitter 0.6 + rand*0.3 {
		moveGravity 200
		colorFade 0.6
		Sprite
	}
}


weapon/shotgun/trail {
// Yep empty and not called
}

// input: origin, dir, team, clientnum, enemy, teammate, ineyes, surfacetype
weapon/machinegun/impact {
	soundList {
		sound/weapons/machinegun/ric1.wav
		sound/weapons/machinegun/ric2.wav
		sound/weapons/machinegun/ric3.wav
	}
	// Bullet mark on the wall
	shader gfx/damage/bullet_mrk
	size 8
	decal

	// explosion cone with animating shader
	size		1
	shader		bulletExplosion
	model		"models/weaphits/bullet.md3"
	rotate		rand*360
	emitter 0.6 {
		dirModel
	}

	// a single sprite shooting up from impact surface
	wobble	dir velocity 10 + rand*30
	scale	velocity velocity 200 + rand*50
	size	2 + rand
	shader	flareShader
	alpha	0.8
	color	1 0.75 0.6
	emitter "0.6 + rand*0.3" {
		moveGravity 200
		colorFade 0.6
		Sprite
	}
}

weapon/machinegun/trail {
// Empty
}
 

// input: origin, team, clientnum, enemy, teammate, ineyes
weapon/gauntlet/flash {
	color	0.3 0.3 0.6
	size 300 + rand*32
	light
}

// input: origin, team, clientnum, enemy, teammate, ineyes
weapon/grapple/flash {
	color	1 0.6 0
	size 300 + rand*32
	light
}


// Render a cheap red beam for the grapple.
// input: origin, angles, velocity, dir (normalized), axis
weapon/grapple/trail {
	size 10
	shader mme/red
	rotate 60
	beam
}

// Just use a rocket as a standard grapple model
// input: velocity, dir (normalized), rotate, origin, angles, axis, size
weapon/grapple/projectile {
	//Render a rocket as a grapple?
	model		"models/ammo/rocket/rocket.md3"
	dirModel
}
